#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "Fish_GiantSharkLevel.h"
std::auto_ptr<Fish_GiantSharkLevel> Fish_GiantSharkLevel::msSingleton(nullptr);

int Fish_GiantSharkLevel::GetCount()
{
	return (int)mMapData.size();
}

const Fish_GiantSharkLevelData* Fish_GiantSharkLevel::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, Fish_GiantSharkLevelData>& Fish_GiantSharkLevel::GetMapData()
{
	return mMapData;
}

void Fish_GiantSharkLevel::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/Fish_GiantSharkLevel.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		Fish_GiantSharkLevelData data;
		data.mID = element->IntAttribute("ID");
		{
			const char* Level = element->Attribute("Level");
			std::vector<std::string> vecLevel;
			boost::split(vecLevel, Level, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecLevel.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecLevel[i].c_str(), &temp))
				{
					data.mLevel.push_back(temp);
				}
			}
		}
		data.mBasicRewards = element->IntAttribute("BasicRewards");
		data.mBrandProbability = element->IntAttribute("BrandProbability");
		data.mNumberCards = element->IntAttribute("NumberCards");
		data.mIntegralAddition = element->IntAttribute("IntegralAddition");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("Fish_GiantSharkLevel Loaded. Load Data:%u", mMapData.size());
}

void Fish_GiantSharkLevel::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/Fish_GiantSharkLevel");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "Fish_GiantSharkLevel");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		Fish_GiantSharkLevelData data;
		LuaCfgHelper::readInt(L, "ID", data.mID);
		LuaCfgHelper::readVectorInt(L, "Level", data.mLevel);
		LuaCfgHelper::readInt(L, "BasicRewards", data.mBasicRewards);
		LuaCfgHelper::readInt(L, "BrandProbability", data.mBrandProbability);
		LuaCfgHelper::readInt(L, "NumberCards", data.mNumberCards);
		LuaCfgHelper::readInt(L, "IntegralAddition", data.mIntegralAddition);
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("Fish_GiantSharkLevel Loaded. Load Data:%u", mMapData.size());
}

void Fish_GiantSharkLevel::Reload()
{
	mMapData.clear();
	Load();
}

Fish_GiantSharkLevel* Fish_GiantSharkLevel::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new Fish_GiantSharkLevel());
	}
	return msSingleton.get();
}

void Fish_GiantSharkLevel::Release()
{
	msSingleton.reset(nullptr);
}
